"use strict";
module.exports = {
  rules: {
    'accidental_assignment': require('./lib/rules/accidental_assignment.js'),
    'assign_to_hostname': require('./lib/rules/assign_to_hostname'),
    'assign_to_href': require('./lib/rules/assign_to_href'),
    'assign_to_location': require('./lib/rules/assign_to_location'),
    'assign_to_mozAudioChannel': require('./lib/rules/assign_to_mozAudioChannel'),
    'assign_to_mozAudioChannelType': require('./lib/rules/assign_to_mozAudioChannelType'),
    'assign_to_onmessage': require('./lib/rules/assign_to_onmessage'),
    'assign_to_pathname': require('./lib/rules/assign_to_pathname'),
    'assign_to_protocol': require('./lib/rules/assign_to_protocol'),
    'assign_to_search': require('./lib/rules/assign_to_search'),
    'assign_to_src': require('./lib/rules/assign_to_src'),
    'call_addEventListener_cellbroadcastmsgchanged': require('./lib/rules/call_addEventListener_cellbroadcastmsgchanged'),
    'call_addEventListener_deviceproximity': require('./lib/rules/call_addEventListener_deviceproximity'),
    'call_addEventListener_message': require('./lib/rules/call_addEventListener_message'),
    'call_addEventListener_moznetworkdownload': require('./lib/rules/call_addEventListener_moznetworkdownload'),
    'call_addEventListener_moznetworkupload': require('./lib/rules/call_addEventListener_moznetworkupload'),
    'call_addEventListener': require('./lib/rules/call_addEventListener'),
    'call_connect': require('./lib/rules/call_connect'),
    'call_eval': require('./lib/rules/call_eval'),
    'call_execScript': require('./lib/rules/call_execScript'),
    'call_Function': require('./lib/rules/call_Function'),
    'call_generateCRMFRequest': require('./lib/rules/call_generateCRMFRequest'),
    'call_getDeviceStorage_apps': require('./lib/rules/call_getDeviceStorage_apps'),
    'call_getDeviceStorage_crashes': require('./lib/rules/call_getDeviceStorage_crashes'),
    'call_getDeviceStorage_music': require('./lib/rules/call_getDeviceStorage_music'),
    'call_getDeviceStorage_pictures': require('./lib/rules/call_getDeviceStorage_pictures'),
    'call_getDeviceStorage_sdcard': require('./lib/rules/call_getDeviceStorage_sdcard'),
    'call_getDeviceStorage_videos': require('./lib/rules/call_getDeviceStorage_videos'),
    'call_hide': require('./lib/rules/call_hide'),
    'call_mozSetMessageHandler_activity': require('./lib/rules/call_mozSetMessageHandler_activity'),
    'call_mozSetMessageHandler': require('./lib/rules/call_mozSetMessageHandler'),
    'call_mozSetMessageHandler_wappush_received': require('./lib/rules/call_mozSetMessageHandler_wappush_received'),
    'call_open_attention': require('./lib/rules/call_open_attention'),
    'call_open_remote=true': require('./lib/rules/call_open_remote=true'),
    'call_parseFromString': require('./lib/rules/call_parseFromString'),
    'call_setAttribute_mozapp': require('./lib/rules/call_setAttribute_mozapp'),
    'call_setAttribute_mozbrowser': require('./lib/rules/call_setAttribute_mozbrowser'),
    'call_setImmediate': require('./lib/rules/call_setImmediate'),
    'call_setInterval': require('./lib/rules/call_setInterval'),
    'call_setMessageHandler_connect': require('./lib/rules/call_setMessageHandler_connect'),
    'call_setTimeout': require('./lib/rules/call_setTimeout'),
    'call_writeln': require('./lib/rules/call_writeln'),
    'call_write': require('./lib/rules/call_write'),
    'identifier_indexedDB': require('./lib/rules/identifier_indexedDB'),
    'identifier_localStorage': require('./lib/rules/identifier_localStorage'),
    'identifier_sessionStorage': require('./lib/rules/identifier_sessionStorage'),
    'new_Function': require('./lib/rules/new_Function'),
    'new_MozActivity': require('./lib/rules/new_MozActivity'),
    'new_MozSpeakerManager': require('./lib/rules/new_MozSpeakerManager'),
    'new_Notification': require('./lib/rules/new_Notification'),
    'object_mozSystem': require('./lib/rules/object_mozSystem'),
    'property_addIdleObserver': require('./lib/rules/property_addIdleObserver'),
    'property_createContextualFragment': require('./lib/rules/property_createContextualFragment'),
    'property_crypto': require('./lib/rules/property_crypto'),
    'property_geolocation': require('./lib/rules/property_geolocation'),
    'property_getDataStores': require('./lib/rules/property_getDataStores'),
    'property_getDeviceStorage': require('./lib/rules/property_getDeviceStorage'),
    'property_getUserMedia': require('./lib/rules/property_getUserMedia'),
    'property_indexedDB': require('./lib/rules/property_indexedDB'),
    'property_lastKnownHomeNetwork': require('./lib/rules/property_lastKnownHomeNetwork'),
    'property_lastKnownNetwork': require('./lib/rules/property_lastKnownNetwork'),
    'property_localStorage': require('./lib/rules/property_localStorage'),
    'property_mgmt': require('./lib/rules/property_mgmt'),
    'property_mozAlarms': require('./lib/rules/property_mozAlarms'),
    'property_mozBluetooth': require('./lib/rules/property_mozBluetooth'),
    'property_mozCameras': require('./lib/rules/property_mozCameras'),
    'property_mozCellBroadcast': require('./lib/rules/property_mozCellBroadcast'),
    'property_mozContacts': require('./lib/rules/property_mozContacts'),
    'property_mozDownloadManager': require('./lib/rules/property_mozDownloadManager'),
    'property_mozFMRadio': require('./lib/rules/property_mozFMRadio'),
    'property_mozInputMethod': require('./lib/rules/property_mozInputMethod'),
    'property_mozKeyboard': require('./lib/rules/property_mozKeyboard'),
    'property_mozMobileConnection': require('./lib/rules/property_mozMobileConnection'),
    'property_mozMobileConnections': require('./lib/rules/property_mozMobileConnections'),
    'property_mozMobileMessage': require('./lib/rules/property_mozMobileMessage'),
    'property_mozNetworkStats': require('./lib/rules/property_mozNetworkStats'),
    'property_mozNfc': require('./lib/rules/property_mozNfc'),
    'property_mozNotification': require('./lib/rules/property_mozNotification'),
    'property_mozPermissionSettings': require('./lib/rules/property_mozPermissionSettings'),
    'property_mozPhoneNumberService': require('./lib/rules/property_mozPhoneNumberService'),
    'property_mozPower': require('./lib/rules/property_mozPower'),
    'property_mozSettings': require('./lib/rules/property_mozSettings'),
    'property_mozTCPSocket': require('./lib/rules/property_mozTCPSocket'),
    'property_mozTelephony': require('./lib/rules/property_mozTelephony'),
    'property_mozTime': require('./lib/rules/property_mozTime'),
    'property_mozVoicemail': require('./lib/rules/property_mozVoicemail'),
    'property_mozWifiManager': require('./lib/rules/property_mozWifiManager'),
    'property_sessionStorage': require('./lib/rules/property_sessionStorage')
  },
  rulesConfig: {
    'accidental_assignment': 2,
    'assign_to_hostname': 2,
    'assign_to_href': 2,
    'assign_to_location': 2,
    'assign_to_mozAudioChannel': 2,
    'assign_to_mozAudioChannelType': 2,
    'assign_to_onmessage': 2,
    'assign_to_pathname': 2,
    'assign_to_protocol': 2,
    'assign_to_search': 2,
    'assign_to_src': 2,
    'call_addEventListener': 2,
    'call_addEventListener_cellbroadcastmsgchanged': 2,
    'call_addEventListener_deviceproximity': 2,
    'call_addEventListener_message': 2,
    'call_addEventListener_moznetworkdownload': 2,
    'call_addEventListener_moznetworkupload': 2,
    'call_connect': 2,
    'call_eval': 2,
    'call_execScript': 2,
    'call_Function': 2,
    'call_generateCRMFRequest': 2,
    'call_getDeviceStorage_apps': 2,
    'call_getDeviceStorage_crashes': 2,
    'call_getDeviceStorage_music': 2,
    'call_getDeviceStorage_pictures': 2,
    'call_getDeviceStorage_sdcard': 2,
    'call_getDeviceStorage_videos': 2,
    'call_hide': 2,
    'call_mozSetMessageHandler': 2,
    'call_mozSetMessageHandler_activity': 2,
    'call_mozSetMessageHandler_wappush_received': 2,
    'call_open_attention': 2,
    'call_open_remote=true': 2,
    'call_parseFromString': 2,
    'call_setAttribute_mozapp': 2,
    'call_setAttribute_mozbrowser': 2,
    'call_setImmediate': 2,
    'call_setInterval': 2,
    'call_setMessageHandler_connect': 2,
    'call_setTimeout': 2,
    'call_write': 2,
    'call_writeln': 2,
    'identifier_indexedDB': 2,
    'identifier_localStorage': 2,
    'identifier_sessionStorage': 2,
    'new_Function': 2,
    'new_MozActivity': 2,
    'new_MozSpeakerManager': 2,
    'new_Notification': 2,
    'object_mozSystem': 2,
    'property_addIdleObserver': 2,
    'property_createContextualFragment': 2,
    'property_crypto': 2,
    'property_geolocation': 2,
    'property_getDataStores': 2,
    'property_getDeviceStorage': 2,
    'property_getUserMedia': 2,
    'property_indexedDB': 2,
    'property_lastKnownHomeNetwork': 2,
    'property_lastKnownNetwork': 2,
    'property_localStorage': 2,
    'property_mgmt': 2,
    'property_mozAlarms': 2,
    'property_mozBluetooth': 2,
    'property_mozCameras': 2,
    'property_mozCellBroadcast': 2,
    'property_mozContacts': 2,
    'property_mozDownloadManager': 2,
    'property_mozFMRadio': 2,
    'property_mozInputMethod': 2,
    'property_mozKeyboard': 2,
    'property_mozMobileConnection': 2,
    'property_mozMobileConnections': 2,
    'property_mozMobileMessage': 2,
    'property_mozNetworkStats': 2,
    'property_mozNfc': 2,
    'property_mozNotification': 2,
    'property_mozPermissionSettings': 2,
    'property_mozPhoneNumberService': 2,
    'property_mozPower': 2,
    'property_mozSettings': 2,
    'property_mozTCPSocket': 2,
    'property_mozTelephony': 2,
    'property_mozTime': 2,
    'property_mozVoicemail': 2,
    'property_mozWifiManager': 2,
    'property_sessionStorage': 2
  }
}
